#-----------------------------------------------------------------------------
%{?!dist:	%define	dist	.ok}
%define		fware		%{_libdir}/firmware
#-----------------------------------------------------------------------------
Name		:	microcode
Version		:	20240312
Release		:	17.0.10.rel%{?dist}
Summary		:	Tool to update x86/x86-64 CPU microcode
Group		:	System Environment/Base

Packager	:	Osukiss Project	<build-ok@osukiss.org>

License		:	GPLv2+
URL		:	https://github.com/intel/Intel-Linux-Processor-Microcode-Data-Files

Source0		:	%{name}-%{version}.tar.gz
Source1		:	%{name}-ok_addon.tar.gz

#-----------------------------------------------------------------------------
BuildRequires	:	iucode-tool

BuildArch	:	noarch

Requires	:	lfs-bootscripts
Requires	:	chkconfig
Requires	:	lsb >= 20170626
#-----------------------------------------------------------------------------
%description
CPU microcode is a mechanism to correct certain errata in existing systems.
The normal preferred method to apply microcode updates is using the system
BIOS, but for a subset of Intel® processors this can be done at runtime 
using the operating system. This package contains those processors that 
support OS loading of microcode updates.

#-----------------------------------------------------------------------------
%files			
%defattr(-, root,root, 0755)
%doc releasenote.md
%attr (0750,root,root) %{_sysconfdir}/rc.d/init.d/%{name}
%{_libdir}/firmware/intel-ucode/*
%{_libdir}/firmware/Intel-ucode.cpio

%preun
if [ "$1" = 0 ]; then
  %{_sbindir}/chkconfig --del %{name}
  fi

%post
%{_sbindir}/chkconfig --add %{name}
%{_sysconfdir}/rc.d/init.d/%{name} restart > /dev/null 2>&1 || :

#=============================================================================
%prep
%setup -q -n Intel-Linux-Processor-Microcode-Data-Files-microcode-%{version}

#-----------------------------------------------------------------------------
#building application
%build
tar xf %{SOURCE1}

#-----------------------------------------------------------------------------
%clean
%{__rm} -rf %{buildroot}

#-----------------------------------------------------------------------------
#installing program
%install
%{__rm} -rf %{buildroot}
%{__mkdir_p} %{buildroot}%{fware}

%{__cp} -a						\
	intel-ucode					\
	%{buildroot}%{fware}

#generating Intle microcode CPIO file
%{_sbindir}/iucode_tool					\
	--normal-earlyfw				\
	--write-earlyfw=Intel-ucode.cpio		\
	 ./intel-ucode

%{__mv}							\
	Intel-ucode.cpio				\
	%{buildroot}%{fware}
	

#installing microcode updating script
%{__mkdir_p} %{buildroot}%{_sysconfdir}/rc.d/init.d
%{__cp} -a 						\
	%{name}-ok_addon/%{name}			\
	%{buildroot}%{_sysconfdir}/rc.d/init.d

#-----------------------------------------------------------------------------
%changelog
